
local module = D:module('no_mercy_helper')

--stuff i used to display the civ's current logic state as waypoint icons
local logictowaypoint = {
	inactive = "wp_powerbutton",
	idle = "wp_target",
	surrender = "wp_standard",
	flee = "wp_talk",
	escort = "wp_escort",
	travel = "wp_exit",
	trade = "wp_scrubs"
}

local orderedwaypoint = {"wp_powerbutton", "wp_target","wp_standard","wp_talk","wp_escort","wp_exit","wp_scrubs"
}
local wpnum = 1

module:hook(GroupAIStateBase, "init", function(self)
	module:call_orig(GroupAIStateBase, "init", self)
	--debug_draw_state is kinda poggers
	--self:set_debug_draw_state(true)
	self._nomercy_created_waypoints = {}
	self._nomercy_assault_occurred = false
	
	self._nomercy_client_submission = {}
	self._nomercy_client_last_vis_check = {}
end)

--[[
module:hook(GroupAIStateBase, "_execute_so", function(self, so_data, so_rooms, so_administered)
	local retval = module:call_orig(GroupAIStateBase, "_execute_so", self, so_data, so_rooms, so_administered)
	if (so_data.AI_group == "civilians") then
		dorhud_log("AAAA! TESTING! " .. so_data.AI_group .. tostring(so_data.search_pos))
		
		if (retval) then
		dorhud_log("RETURN VALUE: " .. tostring(retval.unit:key()))
		end
		--dorhud_log(so_data.search_dis_sq .. "," .. so_data.search_pos .. "," .. so_data.AI_group .. "," .. so_data.access .. ",")
		local max_dis = so_data.search_dis_sq
		local pos = so_data.search_pos
		local ai_group = so_data.AI_group
		local so_access = so_data.access
		local mvec3_dis_sq = mvector3.distance_sq
		local closest_u_data, closest_dis
		local so_objective = so_data.objective
		local nav_manager = managers.navigation
		local access_f = nav_manager.check_access
		if ai_group == "civilians" then
			for u_key, u_unit_data in pairs(managers.enemy:all_civilians()) do
				if (not so_administered or not so_administered[u_key]) and u_unit_data.unit:brain():is_available_for_assignment(so_objective) and (not so_data.verification_clbk or so_data.verification_clbk(u_unit_data.unit)) and access_f(nav_manager, so_access, u_unit_data.so_access, 0) then
					
					
					local dis = mvec3_dis_sq(u_unit_data.m_pos, pos)
					
					dorhud_log("AAAA! " .. tostring(u_unit_data.unit:key()) .. " IS AVAILABLE? DIS = " .. dis)
					managers.hud:add_waypoint(tostring(u_unit_data.unit:key()), {
						icon = orderedwaypoint[wpnum],
						--text = civ.unit:brain()._current_logic_name,
						position = u_unit_data.unit:movement():m_head_pos(),
						distance = false,
						present_timer = 0,
						--timer = (d.submission_meter / d.submission_max) * 100,
						--pause_timer = true,
					})
					if (not closest_dis or closest_dis > dis) and (not max_dis or max_dis > dis) then
						closest_u_data = u_unit_data
						closest_dis = dis
					end

				end
			end
		end
	end
	wpnum = wpnum + 1
	return retval
end)
]]

module:hook(GroupAIStateBase, "update", function(self, t, dt)
	module:call_orig(GroupAIStateBase, "update", self, t, dt)
	
	local is_nm = Global.level_data.level_id == "hospital"
	--only run on No Mercy in whisper mode
	--might have false positives if you join as a client during an assault break
	if (not is_nm or self._nomercy_assault_occurred) then return end
	
	if (self._assault_mode) then
		self._nomercy_assault_occurred = true
		for i, v in pairs(self._nomercy_created_waypoints) do
			managers.hud:remove_waypoint(i)
		end
		self._nomercy_created_waypoints = {}
		return
	end
	--moving to part 2 of plan A puts you back in the mask up state, we don't want any waypoint stuff to be ran then
	if (game_state_machine:current_state_name() == "ingame_mask_off") then
		for i, v in pairs(self._nomercy_created_waypoints) do
			managers.hud:remove_waypoint(i)
		end
		self._nomercy_created_waypoints = {}
		self._nomercy_client_submission = {}
		return
	end
	
	local civs = managers.enemy:all_civilians()
	
	for _, civ in pairs(civs) do
		local key = tostring(civ.unit:key())
		--place exclamation point above head; code from Payday 2
		local icon_pos = mvector3.copy(math.UP)
		mvector3.multiply(icon_pos, 28)
		local observer_pos = civ.unit:movement() and civ.unit:movement():m_head_pos()
		if not observer_pos then
			u_observer:m_position(tmp_vec1)
			observer_pos = tmp_vec1
		end
		mvector3.add(icon_pos, observer_pos)
		--
		
		--simulate submission reduction/addition as a client
		if (not self._nomercy_client_last_vis_check[key]) then self._nomercy_client_last_vis_check[key] = t end
		if (t - self._nomercy_client_last_vis_check[key] > 1) then
			local nm_dt = t - self._nomercy_client_last_vis_check[key]
			if (not Network:is_server() and civ.unit:anim_data().drop) then
				if (not self._nomercy_client_submission[key]) then self._nomercy_client_submission[key] = 0 end
				if (self._nomercy_client_submission[key] > 90) then self._nomercy_client_submission[key] = 90 end
				
				local my_pos = civ.unit:movement():m_head_pos()
				local enemies = managers.groupai:state():all_criminals()
				local visible, closest_dis, closest_enemy
				local my_tracker = civ.unit:movement():nav_tracker()
				local chk_vis_func = my_tracker.check_visibility
				
				for _, record in pairs(enemies) do
					if not record.is_deployable and chk_vis_func(my_tracker, record.tracker) then
						local enemy_unit = record.unit
						local enemy_pos = record.m_det_pos
						local my_vec = my_pos - enemy_pos
						local dis = mvector3.normalize(my_vec)
						if dis < 700 then
							visible = true
						end
						
						if not closest_dis or closest_dis > dis then
							closest_dis = dis
							closest_enemy = enemy_unit
						end

						local look_dir = enemy_unit:movement():m_head_rot():y()
						local enemy_head_pos = enemy_unit:movement():m_head_pos()
						local focus = my_vec:dot(look_dir)
						if focus > 0.65 then
							visible = true
							if focus > 0.8 then
								self._nomercy_client_submission[key] = math.min(90, self._nomercy_client_submission[key] + nm_dt)
							end

						end
						
					end
				end
				if not visible then
					self._nomercy_client_submission[key] = math.max(0, self._nomercy_client_submission[key] - nm_dt)
				end
			else --reset submission when not in "drop" anim
				self._nomercy_client_submission[key] = nil
			end
			self._nomercy_client_last_vis_check[key] = t
		end
		
		local s_meter = nil
		local s_max = nil
		
		--they should always have a submission meter if they're in drop
		if (civ.unit:anim_data().drop) then
			if (Network:is_server()) then
				s_meter = civ.unit:brain()._logic_data.internal_data and civ.unit:brain()._logic_data.internal_data.submission_meter
				s_max = civ.unit:brain()._logic_data.internal_data and civ.unit:brain()._logic_data.internal_data.submission_max
			else
				s_meter = self._nomercy_client_submission[key]
				s_max = 90 --random value between 60 and 120
			end
		end
		
		local displayex = true
		
		--Don't display an exclamation point if we are tied, we are idle, we are walking (not running; spawned staircase guys), or we are fully in submission
		if (civ.unit:anim_data().tied) then displayex = false
		elseif (civ.unit:anim_data().peaceful) then displayex = false
		--elseif (civ.unit:brain()._current_logic_name == "idle") then displayex = false
		elseif (civ.unit:anim_data().move and not civ.unit:anim_data().run) then displayex = false
		--elseif (civ.unit:brain()._current_logic_name == "travel" and not civ.unit:anim_data().run) then displayex = false
		elseif (s_meter and s_meter / s_max >= 0.95) then displayex = false end
		
		if (displayex) then
			if (managers.hud:get_waypoint_data(key) == nil) then
				
				managers.hud:add_waypoint(key, {
					--icon = logictowaypoint[civ.unit:brain()._current_logic_name],
					text = "!",
					position = icon_pos,
					present_timer = 0,
					
					--timer = 0,
					--distance = true,
				})
				self._nomercy_created_waypoints[key] = true
			else
				managers.hud:get_waypoint_data(key).position = icon_pos
				--local icon, texture_rect = tweak_data.hud_icons:get_icon_data(logictowaypoint[civ.unit:brain()._current_logic_name], {0,0,32,32})
				--managers.hud:get_waypoint_data(key).bitmap:set_texture_rect(texture_rect[1], texture_rect[2], texture_rect[3], texture_rect[4])
				
				--[[
				if (s_meter) then
					--dorhud_log(key .. " S_METER: " .. s_meter)
					managers.hud:get_waypoint_data(key).timer = (s_meter / s_max) * 100
					managers.hud:get_waypoint_data(key).timer = s_meter
				end
				]]
			end
		else managers.hud:remove_waypoint(key)
		end
	end
	
end)