
local module = D:module('no_mercy_helper')

module:hook(PlayerStandard, "_get_intimidation_action", function(self, prime_target, char_table)
	local is_nm = Global.level_data.level_id == "hospital"

	--instantly exit out if we aren't in Plan A on No Mercy as a client
	if (not is_nm or Network:is_server() or managers.groupai:state():get_assault_mode()) then return module:call_orig(PlayerStandard, "_get_intimidation_action", self, prime_target, char_table) end
	
	local voice_type, new_action, plural
	local unit_type_enemy = 0
	local unit_type_civilian = 1
	local unit_type_teammate = 2
	
	local submission = managers.groupai:state()._nomercy_client_submission
	local last_check = managers.groupai:state()._nomercy_client_last_vis_check

	if prime_target then
		if prime_target.unit_type ~= unit_type_teammate then
			local max_inv_wgt = 0
			for _, char in pairs(char_table) do
				if max_inv_wgt < char.inv_wgt then
					max_inv_wgt = char.inv_wgt
				end
			end

			if max_inv_wgt < 1 then
				max_inv_wgt = 1
			end
			
			for _, char in pairs(char_table) do
				local key = tostring(char.unit:key())
				
				if (char.unit_type ~= unit_type_teammate and last_check[key]) then
					if prime_target.unit:key() == char.unit:key() then
						--dorhud_log("PRIME TARGET! 60 APPLIED")
						if (not submission[key]) then
							last_check[key] = last_check[key] + 0.2
							submission[key] = 0
						end
						submission[key] =  math.min(90, submission[key] + 60)
					elseif char.unit_type ~= unit_type_enemy then
						--dorhud_log("SECONDARY TARGET! " .. (60 * char.inv_wgt / max_inv_wgt) .. " APPLIED")
						if (not submission[key]) then
							last_check[key] = last_check[key] + 1.2
							submission[key] = 0
						end
						submission[key] =  math.min(90, submission[key] + (60 * char.inv_wgt / max_inv_wgt))
					end
				end
			end

		end

	end
	
	return module:call_orig(PlayerStandard, "_get_intimidation_action", self, prime_target, char_table)
end)